#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/Max6675/max6675.c"

sbit LCD_RS at PORTD2_bit;
sbit LCD_EN at PORTD3_bit;
sbit LCD_D4 at PORTD4_bit;
sbit LCD_D5 at PORTD5_bit;
sbit LCD_D6 at PORTD6_bit;
sbit LCD_D7 at PORTD7_bit;

sbit LCD_RS_Direction at DDD2_bit;
sbit LCD_EN_Direction at DDD3_bit;
sbit LCD_D4_Direction at DDD4_bit;
sbit LCD_D5_Direction at DDD5_bit;
sbit LCD_D6_Direction at DDD6_bit;
sbit LCD_D7_Direction at DDD7_bit;


sbit SoftSpi_SDI at PINB0_bit;
sbit SoftSpi_SDO at PORTB2_bit;
sbit SoftSpi_CLK at PORTB1_bit;
sbit CS at PORTC1_bit;

sbit SoftSpi_SDI_Direction at DDB0_bit;
sbit SoftSpi_SDO_Direction at DDB2_bit;
sbit SoftSpi_CLK_Direction at DDB1_bit;

unsigned int sensor_dato, locked=0, aux=0, chlk=0;
char sensorl, sensorh, ch;
long Temp1, Temp2;

void Temp_reading() {


 CS = 0;
 sensorh = Soft_SPI_Read(170);
 sensorl = Soft_SPI_Read(170);
 sensor_dato=((unsigned int )sensorh <<5) | (sensorl>>3 );
 CS =1;
 Temp1=(sensor_dato*0.25);
 Temp2 =10*((Temp1*1.8)+32);


 ch =(Temp1/ 100 )% 10;
 Lcd_Chr(2,1,48+ch);
 ch =(Temp1/ 10 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = Temp1 % 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,4,223);
 Lcd_Chr(2,5,'C');
 ch = Temp2/1000;
 Lcd_Chr(2,8,48+ch);
 ch =(Temp2/ 100 )% 10;
 Lcd_Chr_CP(48+ch);
 ch =(Temp2/ 10 )% 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,11,'.');
 ch = Temp2 % 10;
 Lcd_Chr(2,12,48+ch);
 Lcd_Chr(2,13,223);
 Lcd_Chr(2,14,'F');
 delay_ms(50);
}

void set_up() {
 DDB0_bit=0;
 DDB1_bit=1;
 DDC1_bit=1;
 Soft_SPI_Init();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 2, "Temperature");
 Lcd_Chr(2,8,223);
 Lcd_Chr(2,9,'C');
}

void main() {
 set_up();
 do{
 Temp_reading();
 } while (1);
}
