#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/Temp_max6675/Version_2/LCD2x16_I2C.c"
#line 1 "c:/users/usuario/documents/mikroc_pro_avr/temp_max6675/version_2/lcd2x16_i2c.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 27 "c:/users/usuario/documents/mikroc_pro_avr/temp_max6675/version_2/lcd2x16_i2c.h"
void I2C_LCD_Init(void);
void I2C_LCD_Cmd(char out_char);
void I2C_LCD_Chr(char row, char column, char out_char);
void I2C_LCD_Chr_Cp(char out_char);
void I2C_LCD_Out(char row, char col, char *text);
void I2C_LCD_Out_Cp(char *text);
#line 5 "C:/Users/Usuario/Documents/MikroC_pro_avr/Temp_max6675/Version_2/LCD2x16_I2C.c"
void I2C_LCD_Cmd(char out_char) {

 char hi_n, lo_n;
 char rs = 0x00;

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 TWI_Start();
 TWI_Write( 0x4E );
 TWI_Write(hi_n | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(hi_n | rs | 0x00 | 0x08);
 Delay_us(100);
 TWI_Write(lo_n | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(lo_n | rs | 0x00 | 0x08);
 TWI_stop();

 if(out_char == 0x01)Delay_ms(2);
}

void I2C_LCD_Chr(char row, char column, char out_char) {

 char hi_n, lo_n;
 char rs = 0x01;

 switch(row){

 case 1:
 I2C_LCD_Cmd(0x80 + (column - 1));
 break;
 case 2:
 I2C_LCD_Cmd(0xC0 + (column - 1));
 break;
 case 3:
 I2C_LCD_Cmd(0x94 + (column - 1));
 break;
 case 4:
 I2C_LCD_Cmd(0xD4 + (column - 1));
 break;
 };

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 TWI_Start();
 TWI_Write( 0x4E );
 TWI_Write(hi_n | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(hi_n | rs | 0x00 | 0x08);
 Delay_us(100);
 TWI_Write(lo_n | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(lo_n | rs | 0x00 | 0x08);
 TWI_stop();
}

void I2C_LCD_Chr_Cp(char out_char) {

 char hi_n, lo_n;
 char rs = 0x01;

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 TWI_Start();
 TWI_Write( 0x4E );
 TWI_Write(hi_n | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(hi_n | rs | 0x00 | 0x08);
 Delay_us(100);
 TWI_Write(lo_n | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(lo_n | rs | 0x00 | 0x08);
 TWI_stop();
}


void I2C_LCD_Init() {

 char rs = 0x00;

 TWI_Start();
 TWI_Write( 0x4E );
 Delay_ms(30);

 TWI_Write(0x30 | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(0x30 | rs | 0x00 | 0x08);
 Delay_ms(10);

 TWI_Write(0x30 | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(0x30 | rs | 0x00 | 0x08);
 Delay_ms(10);

 TWI_Write(0x30 | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(0x30 | rs | 0x00 | 0x08);
 Delay_ms(10);

 TWI_Write(0x20 | rs | 0x04 | 0x08);
 Delay_us(50);
 TWI_Write(0x20 | rs | 0x00 | 0x08);
 TWI_Stop();

 Delay_ms(10);

 I2C_LCD_Cmd(0x28);
 I2C_LCD_Cmd(0x06);
}

void I2C_LCD_Out(char row, char col, char *text) {
 while(*text)
 I2C_LCD_Chr(row, col++, *text++);
}

void I2C_LCD_Out_Cp(char *text) {
 while(*text)
 I2C_LCD_Chr_Cp(*text++);
}
