
_set_up:

;Max6675_V2.c,20 :: 		void set_up() {
;Max6675_V2.c,22 :: 		DDC4_bit=0;   //SDA
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	IN         R27, DDC4_bit+0
	CBR        R27, BitMask(DDC4_bit+0)
	OUT        DDC4_bit+0, R27
;Max6675_V2.c,23 :: 		DDC5_bit=0;   //SDL
	IN         R27, DDC5_bit+0
	CBR        R27, BitMask(DDC5_bit+0)
	OUT        DDC5_bit+0, R27
;Max6675_V2.c,24 :: 		DDD5_bit=0;
	IN         R27, DDD5_bit+0
	CBR        R27, BitMask(DDD5_bit+0)
	OUT        DDD5_bit+0, R27
;Max6675_V2.c,25 :: 		DDD6_bit=1;
	IN         R27, DDD6_bit+0
	SBR        R27, BitMask(DDD6_bit+0)
	OUT        DDD6_bit+0, R27
;Max6675_V2.c,26 :: 		DDD7_bit=1;
	IN         R27, DDD7_bit+0
	SBR        R27, BitMask(DDD7_bit+0)
	OUT        DDD7_bit+0, R27
;Max6675_V2.c,27 :: 		Soft_SPI_Init();
	CALL       _Soft_SPI_Init+0
;Max6675_V2.c,28 :: 		TWI_Init(100000);
	LDS        R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	STS        TWPS0_bit+0, R27
	LDS        R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	STS        TWPS1_bit+0, R27
	LDI        R27, 72
	STS        TWBR+0, R27
	CALL       _TWI_Init+0
;Max6675_V2.c,29 :: 		I2C_LCD_Init();
	CALL       _I2C_LCD_Init+0
;Max6675_V2.c,30 :: 		I2C_LCD_Cmd(_LCD_CURSOR_OFF);
	LDI        R27, 12
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;Max6675_V2.c,31 :: 		I2C_LCD_Cmd(_LCD_CLEAR);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _I2C_LCD_Cmd+0
;Max6675_V2.c,32 :: 		I2C_Lcd_Out(1,1,txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _I2C_LCD_Out+0
;Max6675_V2.c,33 :: 		}
L_end_set_up:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _set_up

_Temp_reading:

;Max6675_V2.c,35 :: 		void Temp_reading() {
;Max6675_V2.c,38 :: 		CS = 0;
	PUSH       R2
	PUSH       R3
	PUSH       R4
	IN         R27, PORTD6_bit+0
	CBR        R27, BitMask(PORTD6_bit+0)
	OUT        PORTD6_bit+0, R27
;Max6675_V2.c,39 :: 		sensorh = Soft_SPI_Read(170);
	LDI        R27, 170
	MOV        R2, R27
	CALL       _Soft_SPI_Read+0
	STS        _sensorh+0, R16
;Max6675_V2.c,40 :: 		sensorl = Soft_SPI_Read(170);
	LDI        R27, 170
	MOV        R2, R27
	CALL       _Soft_SPI_Read+0
	STS        _sensorl+0, R16
;Max6675_V2.c,41 :: 		sensor_dato=((unsigned int )sensorh <<5) | (sensorl>>3 );
	LDS        R20, _sensorh+0
	LDI        R21, 0
	LDI        R27, 5
	MOVW       R18, R20
L__Temp_reading9:
	LSL        R18
	ROL        R19
	DEC        R27
	BRNE       L__Temp_reading9
L__Temp_reading10:
	LSR        R16
	LSR        R16
	LSR        R16
	LDI        R17, 0
	OR         R16, R18
	OR         R17, R19
	STS        _sensor_dato+0, R16
	STS        _sensor_dato+1, R17
;Max6675_V2.c,42 :: 		CS =1;
	IN         R27, PORTD6_bit+0
	SBR        R27, BitMask(PORTD6_bit+0)
	OUT        PORTD6_bit+0, R27
;Max6675_V2.c,43 :: 		Temp1=(sensor_dato*0.25);
	LDI        R18, 0
	MOV        R19, R18
	CALL       _float_ulong2fp+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 128
	LDI        R23, 62
	CALL       _float_fpmul1+0
	CALL       _float_fpint+0
	STS        _Temp1+0, R16
	STS        _Temp1+1, R17
	STS        _Temp1+2, R18
	STS        _Temp1+3, R19
;Max6675_V2.c,44 :: 		Temp2 =10*((Temp1*1.8)+32);
	CALL       _float_slong2fp+0
	LDI        R20, 102
	LDI        R21, 102
	LDI        R22, 230
	LDI        R23, 63
	CALL       _float_fpmul1+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 66
	CALL       _float_fpadd1+0
	LDI        R20, 0
	LDI        R21, 0
	LDI        R22, 32
	LDI        R23, 65
	CALL       _float_fpmul1+0
	CALL       _float_fpint+0
	STS        _Temp2+0, R16
	STS        _Temp2+1, R17
	STS        _Temp2+2, R18
	STS        _Temp2+3, R19
;Max6675_V2.c,47 :: 		ch =(Temp1/ 100 )% 10;
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp1+0
	LDS        R17, _Temp1+1
	LDS        R18, _Temp1+2
	LDS        R19, _Temp1+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
	STS        _ch+0, R16
;Max6675_V2.c,48 :: 		I2C_LCD_Chr(2,1,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,49 :: 		ch =(Temp1/ 10 )% 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp1+0
	LDS        R17, _Temp1+1
	LDS        R18, _Temp1+2
	LDS        R19, _Temp1+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
	STS        _ch+0, R16
;Max6675_V2.c,50 :: 		I2C_LCD_Chr_Cp(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
;Max6675_V2.c,51 :: 		ch = Temp1 % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp1+0
	LDS        R17, _Temp1+1
	LDS        R18, _Temp1+2
	LDS        R19, _Temp1+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
	STS        _ch+0, R16
;Max6675_V2.c,52 :: 		I2C_LCD_Chr_Cp(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
;Max6675_V2.c,53 :: 		I2C_LCD_Chr(2,4,223);   // Print degree character for Centigrades.
	LDI        R27, 223
	MOV        R4, R27
	LDI        R27, 4
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,54 :: 		I2C_LCD_Chr(2,5,'C');
	LDI        R27, 67
	MOV        R4, R27
	LDI        R27, 5
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,55 :: 		ch = Temp2/1000;
	LDI        R20, 232
	LDI        R21, 3
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp2+0
	LDS        R17, _Temp2+1
	LDS        R18, _Temp2+2
	LDS        R19, _Temp2+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	STS        _ch+0, R16
;Max6675_V2.c,56 :: 		I2C_LCD_Chr(2,8,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 8
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,57 :: 		ch =(Temp2/ 100 )% 10;
	LDI        R20, 100
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp2+0
	LDS        R17, _Temp2+1
	LDS        R18, _Temp2+2
	LDS        R19, _Temp2+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
	STS        _ch+0, R16
;Max6675_V2.c,58 :: 		I2C_LCD_Chr_Cp(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
;Max6675_V2.c,59 :: 		ch =(Temp2/ 10 )% 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp2+0
	LDS        R17, _Temp2+1
	LDS        R18, _Temp2+2
	LDS        R19, _Temp2+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R18
	MOVW       R18, R20
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
	STS        _ch+0, R16
;Max6675_V2.c,60 :: 		I2C_LCD_Chr_Cp(48+ch);
	SUBI       R16, 208
	MOV        R2, R16
	CALL       _I2C_LCD_Chr_Cp+0
;Max6675_V2.c,61 :: 		I2C_LCD_Chr(2,11,'.');
	LDI        R27, 46
	MOV        R4, R27
	LDI        R27, 11
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,62 :: 		ch = Temp2 % 10;
	LDI        R20, 10
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDS        R16, _Temp2+0
	LDS        R17, _Temp2+1
	LDS        R18, _Temp2+2
	LDS        R19, _Temp2+3
	CALL       _Div_32x32_S+0
	MOVW       R16, R22
	MOVW       R18, R24
	STS        _ch+0, R16
;Max6675_V2.c,63 :: 		I2C_LCD_Chr(2,12,48+ch);
	SUBI       R16, 208
	MOV        R4, R16
	LDI        R27, 12
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,64 :: 		I2C_LCD_Chr(2,13,223);   // Print degree character for Centigrades.
	LDI        R27, 223
	MOV        R4, R27
	LDI        R27, 13
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,65 :: 		I2C_LCD_Chr(2,14,'F');
	LDI        R27, 70
	MOV        R4, R27
	LDI        R27, 14
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _I2C_LCD_Chr+0
;Max6675_V2.c,66 :: 		delay_ms(50);
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L_Temp_reading0:
	DEC        R16
	BRNE       L_Temp_reading0
	DEC        R17
	BRNE       L_Temp_reading0
	DEC        R18
	BRNE       L_Temp_reading0
;Max6675_V2.c,67 :: 		}
L_end_Temp_reading:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _Temp_reading

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;Max6675_V2.c,69 :: 		void main() {
;Max6675_V2.c,70 :: 		set_up();
	CALL       _set_up+0
;Max6675_V2.c,71 :: 		do{
L_main2:
;Max6675_V2.c,72 :: 		Temp_reading();
	CALL       _Temp_reading+0
;Max6675_V2.c,73 :: 		delay_ms(500);
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L_main5:
	DEC        R16
	BRNE       L_main5
	DEC        R17
	BRNE       L_main5
	DEC        R18
	BRNE       L_main5
;Max6675_V2.c,74 :: 		} while (1);
	JMP        L_main2
;Max6675_V2.c,75 :: 		}
L_end_main:
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
