
#include "built_in.h"
#include "LCD2X16_I2C.h"

sbit SoftSpi_SDI at PIND5_bit;
sbit SoftSpi_SDO at PORTB2_bit; //doesnt use but is necessary to declare this pin
sbit SoftSpi_CLK at PORTD7_bit;
sbit CS at PORTD6_bit;

sbit SoftSpi_SDI_Direction at DDD5_bit;
sbit SoftSpi_SDO_Direction at DDB2_bit;   //you must declare this pin
sbit SoftSpi_CLK_Direction at DDD7_bit;

unsigned int sensor_dato, locked=0, aux=0, chlk=0;
char sensorl, sensorh, ch;
long Temp1, Temp2;

char txt[] = "TEMPERATURE";

void set_up() {

  DDC4_bit=0;   //SDA
  DDC5_bit=0;   //SDL
  DDD5_bit=0;
  DDD6_bit=1;
  DDD7_bit=1;
  Soft_SPI_Init();
  TWI_Init(100000);
  I2C_LCD_Init();
  I2C_LCD_Cmd(_LCD_CURSOR_OFF);
  I2C_LCD_Cmd(_LCD_CLEAR);
  I2C_Lcd_Out(1,1,txt);
}

void Temp_reading() {

//  Reading the temperature
    CS = 0;
    sensorh = Soft_SPI_Read(170);
    sensorl = Soft_SPI_Read(170);
    sensor_dato=((unsigned int )sensorh <<5) | (sensorl>>3 );
    CS =1;
    Temp1=(sensor_dato*0.25);
    Temp2 =10*((Temp1*1.8)+32);
    //ch = Temp1/1000;
    //I2C_LCD_Chr(2,4,48+ch);
    ch =(Temp1/ 100 )% 10;
    I2C_LCD_Chr(2,1,48+ch);
    ch =(Temp1/ 10 )% 10;
    I2C_LCD_Chr_Cp(48+ch);
    ch = Temp1 % 10;
    I2C_LCD_Chr_Cp(48+ch);
    I2C_LCD_Chr(2,4,223);   // Print degree character for Centigrades.
    I2C_LCD_Chr(2,5,'C');
    ch = Temp2/1000;
    I2C_LCD_Chr(2,8,48+ch);
    ch =(Temp2/ 100 )% 10;
    I2C_LCD_Chr_Cp(48+ch);
    ch =(Temp2/ 10 )% 10;
    I2C_LCD_Chr_Cp(48+ch);
    I2C_LCD_Chr(2,11,'.');
    ch = Temp2 % 10;
    I2C_LCD_Chr(2,12,48+ch);
    I2C_LCD_Chr(2,13,223);   // Print degree character for Centigrades.
    I2C_LCD_Chr(2,14,'F');
    delay_ms(50);
}

void main() {
  set_up();
   do{
      Temp_reading();
      delay_ms(500);
 } while (1);
}