#line 1 "C:/Users/Usuario/Documents/MikroC_pro_avr/Temp_max6675/Version_2/Max6675_V2.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 1 "c:/users/usuario/documents/mikroc_pro_avr/temp_max6675/version_2/lcd2x16_i2c.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 27 "c:/users/usuario/documents/mikroc_pro_avr/temp_max6675/version_2/lcd2x16_i2c.h"
void I2C_LCD_Init(void);
void I2C_LCD_Cmd(char out_char);
void I2C_LCD_Chr(char row, char column, char out_char);
void I2C_LCD_Chr_Cp(char out_char);
void I2C_LCD_Out(char row, char col, char *text);
void I2C_LCD_Out_Cp(char *text);
#line 5 "C:/Users/Usuario/Documents/MikroC_pro_avr/Temp_max6675/Version_2/Max6675_V2.c"
sbit SoftSpi_SDI at PIND5_bit;
sbit SoftSpi_SDO at PORTB2_bit;
sbit SoftSpi_CLK at PORTD7_bit;
sbit CS at PORTD6_bit;

sbit SoftSpi_SDI_Direction at DDD5_bit;
sbit SoftSpi_SDO_Direction at DDB2_bit;
sbit SoftSpi_CLK_Direction at DDD7_bit;

unsigned int sensor_dato, locked=0, aux=0, chlk=0;
char sensorl, sensorh, ch;
long Temp1, Temp2;

char txt[] = "TEMPERATURE";

void set_up() {

 DDC4_bit=0;
 DDC5_bit=0;
 DDD5_bit=0;
 DDD6_bit=1;
 DDD7_bit=1;
 Soft_SPI_Init();
 TWI_Init(100000);
 I2C_LCD_Init();
 I2C_LCD_Cmd( 0x0C );
 I2C_LCD_Cmd( 0x01 );
 I2C_Lcd_Out(1,1,txt);
}

void Temp_reading() {


 CS = 0;
 sensorh = Soft_SPI_Read(170);
 sensorl = Soft_SPI_Read(170);
 sensor_dato=((unsigned int )sensorh <<5) | (sensorl>>3 );
 CS =1;
 Temp1=(sensor_dato*0.25);
 Temp2 =10*((Temp1*1.8)+32);


 ch =(Temp1/ 100 )% 10;
 I2C_LCD_Chr(2,1,48+ch);
 ch =(Temp1/ 10 )% 10;
 I2C_LCD_Chr_Cp(48+ch);
 ch = Temp1 % 10;
 I2C_LCD_Chr_Cp(48+ch);
 I2C_LCD_Chr(2,4,223);
 I2C_LCD_Chr(2,5,'C');
 ch = Temp2/1000;
 I2C_LCD_Chr(2,8,48+ch);
 ch =(Temp2/ 100 )% 10;
 I2C_LCD_Chr_Cp(48+ch);
 ch =(Temp2/ 10 )% 10;
 I2C_LCD_Chr_Cp(48+ch);
 I2C_LCD_Chr(2,11,'.');
 ch = Temp2 % 10;
 I2C_LCD_Chr(2,12,48+ch);
 I2C_LCD_Chr(2,13,223);
 I2C_LCD_Chr(2,14,'F');
 delay_ms(50);
}

void main() {
 set_up();
 do{
 Temp_reading();
 delay_ms(500);
 } while (1);
}
